#ifndef MAZE_H
#define MAZE_H

#include <iostream>
using std::ostream;


class Maze {
    friend ostream & operator<<(ostream &output, const Maze &mz);
public:
    Maze();  // default constructor
    Maze(const char *filename);  // constructor - read maze from file
    Maze(const Maze &copy);
    ~Maze(); // destructor
    const Maze & operator=(const Maze &rhs);
    bool read(const char *filename);      // read maze out of file
    void show(ostream &output) const;  // display contents of maze
    bool step(ostream &output);  // returns 0 if we cannot move, or we've
                                  //  reached the end
    void traverse(ostream &output); // traverse the maze, at each step writing
                                    // an image of the maze to output
    void generate_new();    // generate a random maze of a random size
private:
    char *maze;
    int cur_row;
    int cur_col;
    int num_rows;
    int num_cols;
};

#endif
